/*
 * pi3's Linux kernel Runtime Guard
 *
 * Component:
 *  - Intercept 'ttwu_do_wakeup' function
 *
 * Notes:
 *  - Enforce Exploit Detection and pCFI
 *
 * Caveats:
 *  - None
 *
 * Timeline:
 *  - Created: 15.III.2020
 *
 * Author:
 *  - Adam 'pi3' Zabrocki (http://pi3.com.pl)
 *
 */

#ifndef P_LKRG_EXPLOIT_DETECTION_TTWU_DO_WAKEUP_H
#define P_LKRG_EXPLOIT_DETECTION_TTWU_DO_WAKEUP_H

/* per-instance private data */
struct p_ttwu_do_wakeup_data {
    ktime_t entry_stamp;
};


int p_ttwu_do_wakeup_ret(struct kretprobe_instance *p_ri, struct pt_regs *p_regs);
int p_ttwu_do_wakeup_entry(struct kretprobe_instance *p_ri, struct pt_regs *p_regs);
int p_install_ttwu_do_wakeup_hook(int p_isra);
void p_uninstall_ttwu_do_wakeup_hook(void);

#endif
